#!/bin/sh

# This script 
# - reads some C/C++-source from standard input,
# - escapes certain characters and strings using sed to protect them
#   against m4, 
# - applies the m4 script '/replace_layout_pre_hxx_defines.m4' that
#   must reside in the same directory as this shell script,
# - unescapes possibly still escaped characters and strings 
# - outputs the result to stdout. 

cat \
    | sed 's/\/\*/§\/*/g' \
    | sed 's/\*\//*\/@/g' \
    | sed 's/\/\/\(.*\)/§\/\/\1@/g' \
    | sed 's/"\(.*\)"/§"\1"@/g' \
    | sed 's/(/~%/g' \
    | sed 's/)/#~/g' \
    | m4 -P "`dirname $0`/replace_layout_pre_hxx_defines.m4" - \
    | sed 's/~%/(/g' \
    | sed 's/#~/)/g' \
    | sed 's/§\(.*\)@/\1/g'